(function ($, Drupal) {
  Drupal.behaviors.musaed = {
    attach: function (context, settings) {
      let musaedProvider = drupalSettings.musaed.musaed_provider;
      let cid = drupalSettings.musaed.cid;

      let retries = 0;
      const init = async () => {
        try {
          window.musaed = {
            conf: {
              cid: cid,
            },
          };
          const res = await fetch(
            musaedProvider + "?_format=json&cid=" + window.musaed.conf.cid,
            {
              headers: {
                "request-origin": window.location.hostname,
              },
            }
          );
          const json = await res.json();
          const script = document.createElement("script");
          const style = document.createElement("style");

          script.innerHTML = json.js;
          style.innerHTML = json.css;
          script.setAttribute("type", "text/javascript");
          style.setAttribute("type", "text/css");
          document.head.appendChild(style);
          document.body.appendChild(script);
        } catch (err) {
          if (retries < 3) {
            retries++;
            init();
          } else {
            console.error("Musaed load failed please contact support");
          }
        }
      };
      init();
    },
  };
})(jQuery, Drupal);
