<?php

declare(strict_types=1);

namespace Drupal\musaed\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure Musaed settings for this site.
 */
final class MusaedConfigrationSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId(): string {
    return 'musaed_musaed_configration_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames(): array {
    return ['musaed.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state): array {
    $form['musaed_provider'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Musaed Provider'),
      '#default_value' => $this->config('musaed.settings')->get('musaed_provider'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state): void {
    $this->config('musaed.settings')
      ->set('musaed_provider', $form_state->getValue('musaed_provider'))
      ->save();
    parent::submitForm($form, $form_state);
  }

}
