<?php

namespace Drupal\musaed\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a musaed block block.
 *
 * @Block(
 *   id = "musaed_block",
 *   admin_label = @Translation("Musaed Block"),
 *   category = @Translation("Musaed"),
 * )
 */
class MusaedBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return [
      'client_id' => 'xxx.xxx.xxx',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function blockForm($form, FormStateInterface $form_state): array {
    $form['client_id'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Client ID'),
      '#default_value' => $this->configuration['client_id'],
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function blockSubmit($form, FormStateInterface $form_state): void {
    $this->configuration['client_id'] = $form_state->getValue('client_id');
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheMaxAge(): int {
    return 0;
  }

  /**
   * {@inheritdoc}
   */
  public function build(): array {

    $build['content'] = [
      '#theme' => 'musaed_block',
      '#attached' => [
        'library' => [
          'musaed/musaed-js',
        ],
        'drupalSettings' => [
          'musaed' => [
            'musaed_provider' => \Drupal::configFactory()->getEditable('musaed.settings')->get('musaed_provider'),
            'cid' => $this->configuration['client_id'],
          ],
        ],

      ],

    ];
    return $build;
  }

}
